NX.define("Nexus.clm.SettingsView",{extend:"Ext.Panel",requires:["Nexus.staging.repository.activity.EventDetail"],requirejs:["nexus/siesta","nexus/clm"],mixins:["Nexus.LogAwareMixin"],constructor:function(config){var self=this;self.clmServerURL=new Ext.form.TextField({name:"clmServerURL",fieldLabel:"CLM Server URL",helpText:"The address of your CLM Server",anchor:Sonatype.view.FIELD_OFFSET,allowBlank:false,itemCls:"required-field",validator:function(v){if(v===""||v.match(/^(?:http|https):\/\//i)){return true}else{return"Protocol must be http:// or https://"}}});self.settingsForm=new Ext.FormPanel({border:false,labelWidth:100,layoutConfig:{labelSeparator:""},items:[self.clmServerURL,{xtype:"textarea",fieldLabel:"Properties",name:"clmConfiguration",anchor:Sonatype.view.FIELD_OFFSET,helpText:"Additional properties to configure for the CLM Server",flex:1}],buttons:[{text:"Save",tooltip:"Save settings",formBind:true,scope:self,handler:self.saveSettings},{text:"Reset",tooltip:"Reset changes",formBind:true,scope:this,handler:self.loadSettings}]});Ext.apply(self,{cls:"nx-clm-SettingsView",border:false,layout:"vbox",layoutConfig:{align:"stretch"},items:[{xtype:"fieldset",title:"Settings",anchor:Sonatype.view.FIELDSET_OFFSET,autoHeight:true,items:[{border:false,html:'<div class="nx-clm-doco"><a href="http://links.sonatype.com/products/clm/nexus/home"  target="_blank">Make Nexus Staging even more powerful with Sonatype CLM </a></div>'},self.settingsForm]}]});self.constructor.superclass.constructor.apply(self,arguments);self.on("afterlayout",self.loadSettings,self,{single:true})},saveSettings:function(){var self=this,form;self.logDebug("CLM Saving settings");form=self.settingsForm.getForm();if(!form.isValid()){return}Ext.Ajax.request({url:Nexus.clm.resourcePath,method:"POST",scope:self,suppressStatus:400,jsonData:{clmServerURL:form.findField("clmServerURL").getValue(),clmConfiguration:form.findField("clmConfiguration").getValue()},success:function(){Nexus.clm.showMessage("Configuration saved");form.items.each(function(item){item.clearInvalid()})},failure:function(response,opts){if(response.siestaValidationError!==undefined){Ext.each(response.siestaValidationError,function(error){form.findField(error.id).markInvalid(error.message)})}}})},loadSettings:function(){var self=this;self.logDebug("CLM Loading settings");Ext.Ajax.request({url:Nexus.clm.resourcePath,method:"GET",scope:self,success:function(response){self.settingsForm.getForm().setValues(Ext.decode(response.responseText));self.logDebug("CLM Settings loaded")}})}},function(){var type=this;var key=Nexus.clm.STAGING_KEY;var label=Nexus.clm.STAGING_LABEL;Sonatype.Events.addListener("nexusNavigationInit",function(nexusPanel){var p=Sonatype.lib.Permissions;if(p.checkPermission("nexus:settings",p.READ)){nexusPanel.add({enabled:true,sectionId:"st-nexus-config",title:Nexus.clm.TITLE,tabId:Nexus.clm.TAB_ID,tabTitle:Nexus.clm.TAB_TITLE,tabCode:type})}});Sonatype.Events.addListener("stagingProfileLoaded",function(items,properties,dataRoot){NX.log.debug("Enhancing UI with CLM details.");var field=new Ext.form.TextField({fieldLabel:label,name:dataRoot+"."+key,value:properties[key],width:376});var help=new Ext.ToolTip({html:'Enter the CLM Application Id here to enable policy enforcement for this profile.<br/><a href="http://links.sonatype.com/products/clm/nexus/home"  target="_blank">Make Nexus Staging even more powerful with Sonatype CLM </a>',anchor:"left",hideDelay:10000});field.on("afterRender",function(field){var wrapDiv=field.getEl().up("div.x-form-element");var helpMark=wrapDiv.createChild({tag:"img",src:Sonatype.config.resourcePath+"/images/icons/help.png",width:16,height:16,cls:"form-label-helpmark"});help.initTarget(helpMark)});items.push(field)});Sonatype.Events.addListener("stagingProfileSubmit",function(referenceData){NX.log.debug("Enhancing submit data with CLM details.");referenceData[key]=null});Nexus.staging.repository.activity.EventDetail.registerBodyTemplateFactory("ruleFailed",Nexus.clm.stagingRule);Nexus.staging.repository.activity.EventDetail.registerBodyTemplateFactory("rulePassed",Nexus.clm.stagingRule)});
define("nexus/clm",["Nexus/config","Nexus/messages","nexus/siesta"],function(){Ext.namespace("Nexus.clm");Nexus.clm.ID="nx-clm";Nexus.clm.TITLE="CLM";Nexus.clm.TAB_TITLE="CLM";Nexus.clm.TAB_ID="clm";Nexus.clm.STAGING_KEY="CLMApplicationID";Nexus.clm.STAGING_LABEL="CLM Application Id";Nexus.clm.showMessage=function(message){Nexus.messages.show(Nexus.clm.TITLE,message)};Nexus.clm.resourcePath=Nexus.siesta.basePath+"/clm";Nexus.clm.ruleTemplate=NX.create("Ext.XTemplate",'<div class="nx-clm-status {messageClass}">{message}</div>','<div class="nx-staging-repository-ActivityView-messagePanel-head">Found <b>{violationCount} violations</b> in <b>{componentCount} components</b></div>','<div class="nx-clm-alerts">','<tpl if="criticalCount &gt; 0">','<div class="nx-clm-alert_box">','<div class="nx-clm-alert nx-clm-alert_critical">{criticalCount}</div>','<div class="nx-clm-alert_critical_text">CRITICAL</div>',"</div>","</tpl>",'<tpl if="severeCount &gt; 0">','<div class="nx-clm-alert_box">','<div class="nx-clm-alert nx-clm-alert_severe">{severeCount}</div>','<div class="nx-clm-alert_severe_text">SEVERE</div>',"</div>","</tpl>",'<tpl if="moderateCount &gt; 0">','<div class="nx-clm-alert_box">','<div class="nx-clm-alert nx-clm-alert_moderate">{moderateCount}</div>','<div class="nx-clm-alert_moderate_text">MODERATE</div>',"</div>","</tpl>",'<a href="{detailedReport}" target="_blank" class="view-report-button">View Full Report</a>',"</div>",'<br style="clear:both;"/>',{compiled:true});Nexus.clm.stagingRule=function(event,detail){if(detail.getPropertyValue("typeId")==="clm"){var message,messageClass;var status=detail.getPropertyValue("x.appScan.status");if(status===undefined){NX.log.error("Unable to determine status for CLM result:"+detail);return undefined}switch(status){case"PASS":message="Validation was successful!";messageClass="nx-clm-status_success";break;case"WARN":message="There are warnings.";messageClass="nx-clm-status_warn";break;case"FAIL":message="Validation failed.";messageClass="nx-clm-status_fail";break;default:Nexus.clm.showMessage("Unrecognized CLM status: "+details.getPropertyValue("x.appScan.status"))}var componentCount=detail.getPropertyValue("x.appScan.componentCount")||0;var violationCount=detail.getPropertyValue("x.appScan.violationCount")||0;var criticalCount=detail.getPropertyValue("x.appScan.threatLevelCount.CRITICAL")||0;var severeCount=detail.getPropertyValue("x.appScan.threatLevelCount.SEVERE")||0;var moderateCount=detail.getPropertyValue("x.appScan.threatLevelCount.MODERATE")||0;return NX.create("Ext.XTemplate","{[ this.render() ]}",{compiled:true,render:function(){return Nexus.clm.ruleTemplate.apply({message:message,messageClass:messageClass,detailedReport:detail.getPropertyValue("x.appScan.url"),componentCount:componentCount,violationCount:violationCount,criticalCount:criticalCount,severeCount:severeCount,moderateCount:moderateCount})}})}return undefined}});
define("nexus-clm-plugin-boot",["Nexus/clm/SettingsView"]);
