NX.define("Nexus.ssl.AbstractCertificateTab",{extend:"Ext.Panel",requires:["Nexus.ssl.CertificateStore","Nexus.ssl.certificate.CertificateDetailsView"],requirejs:["Nexus/config"],type:"repository",trustKeyUrl:function(){return Sonatype.config.contextPath+"/service/siesta/ssl/truststore/key/"+this.type+"/"+this.data.id},initComponent:function(){var self=this;self.certificateUrl=Sonatype.config.contextPath+"/service/siesta/ssl/certificates";self.trustUrl=Sonatype.config.contextPath+"/service/siesta/ssl/truststore";self.layout="fit";self.items=[{xtype:"panel",autoScroll:true,layout:{type:"vbox",align:"stretch",defaultMargins:{top:0,left:20,right:20,bottom:0}},items:[{xtype:"panel",layout:"hbox",items:[{xtype:"checkbox",name:"use-truststore",flex:0,listeners:{check:function(cmp,checked){if(this.submitState){self.setUseTrustStore(checked)}},render:function(){this.submitState=true}}},{xtype:"label",text:"Use Nexus SSL trust store",style:"padding-top: 5px;"},{xtype:"panel",html:"&nbsp;",flex:1},{xtype:"button",name:"trust-certificate",text:"Add to trust store",width:150,disabled:true,handler:function(){if(!self.certificate){throw new Error("No certificate available")}var btn=this,record=Nexus.ssl.CertificateStore.getById(self.certificate.id);if(record){Sonatype.MessageBox.show({animEl:this.getEl(),title:"Nexus needs to be restarted",msg:"You need to restart Nexus to make sure<br/> the certificate is not used anymore.",buttons:Sonatype.MessageBox.OK,scope:this,icon:Sonatype.MessageBox.WARNING,fn:function(btnName){if(btnName==="yes"||btnName==="ok"){Nexus.ssl.CertificateStore.remove(record);btn.setAddText()}}})}else{self.addCertificate(self.certificate.pem,function(){btn.setRemoveText();Nexus.ssl.CertificateStore.reload()})}},setAddText:function(){this.setText("Add to trust store")},setRemoveText:function(){this.setText("Remove from trust store")},listeners:{show:function(){if(!self.certificate){return}if(Nexus.ssl.CertificateStore.getById(self.certificate.id)){this.setRemoveText()}}}}]},{xtype:"panel",name:"certificate-details",title:"Certificate",autoScroll:true,flex:1,items:[{xtype:"certificate-details",certificate:{}}]}]}];Ext.Panel.prototype.initComponent.apply(self,arguments);self.on("activate",function(){self.loadSettings();self.loadCertificate()},self,{single:true})},loadSettings:function(){var self=this;Ext.Ajax.request({url:this.trustKeyUrl(),success:function(response){var data=Ext.decode(response.responseText),checkbox=self.find("name","use-truststore")[0];checkbox.submitState=false;checkbox.setValue(data.enabled);checkbox.submitState=true}})},setUseTrustStore:function(enable){var self=this,mask=new Ext.LoadMask(self.el,{msg:"Saving settings...",removeMask:true});mask.show();Ext.Ajax.request({url:self.trustKeyUrl(),method:"PUT",jsonData:{enabled:enable},callback:function(){mask.hide()}})},addCertificate:function(pem,callback){var self=this;Ext.Ajax.request({url:self.trustUrl,jsonData:{value:pem},callback:callback})},loadCertificate:function(){var self=this,mask={hide:Ext.emptyFn},button=self.find("name","trust-certificate")[0],parent=self.findParentByType("tabpanel"),details=self.find("name","certificate-details")[0];if(details.el){mask=new Ext.LoadMask(details.el,{msg:"Retrieving certificate...",removeMask:true});mask.show()}self.certificate=undefined;button.disable();Ext.Ajax.request({method:"GET",url:self.certificateUrl,params:self.certRequestParams,callback:function(){mask.hide()},success:function(response){details.removeAll();self.certificate=Ext.decode(response.responseText);if(self.certificate.inNexusSSLTrustStore){button.setRemoveText()}else{button.setAddText()}button.enable();details.add(new Nexus.ssl.certificate.CertificateDetailsView({certificate:self.certificate}));parent.doLayout()},failure:function(response){Ext.MessageBox.hide();details.removeAll();self.certificate=undefined;button.disable();if(response.siestaError){details.add(new Nexus.ssl.certificate.CertificateDetailsView.RETRIEVE_ERROR(response.siestaError.message))}else{if(response.siestaValidationErrors){var msg="";Ext.each(response.siestaValidationErrors,function(item){msg+=item.message+"<br/>"});details.add(new Nexus.ssl.certificate.CertificateDetailsView.RETRIEVE_ERROR(msg))}else{details.add(Nexus.ssl.certificate.CertificateDetailsView.COULD_NOT_RETRIEVE)}}parent.doLayout()}})},refreshContent:function(){this.loadSettings();this.loadCertificate()}});
NX.define("Nexus.ssl.CertificateStore",{extend:"Ext.data.Store",requireSuper:false,singleton:true,constructor:function(){var self=this,url=Sonatype.config.contextPath+"/service/siesta/ssl/truststore";self.autoSave=true;self.restful=true;self.reader=new Ext.data.JsonReader({idProperty:"id",fields:["id","subjectCommonName","subjectOrganization","subjectOrganizationalUnit","issuerCommonName","issuerOrganization","issuerOrganizationalUnit","fingerprint","pem","serialNumber","issuedOn","expiresOn"]});self.writer=new Ext.data.JsonWriter({encode:false,writeAllFields:true,render:function(params,baseParams,data){Ext.applyIf(data,params,baseParams);params.jsonData=data}});self.proxy=new Ext.data.HttpProxy({api:{read:{url:url,method:"GET"},create:{url:url,method:"POST"},update:{url:url,method:"PUT"},destroy:{url:url,method:"DELETE"}}});self.listeners={beforewrite:function(store,action,rs){rs.dirty=false}};self.constructor.superclass.constructor.apply(self,arguments)}});
NX.define("Nexus.ssl.Icons",{extend:"Nexus.util.IconContainer",singleton:true,constructor:function(){var self=this;self.constructor.superclass.constructor.call(self,{stylePrefix:"nexus-ssl-icon-",icons:{certificate:"ssl_certificates.png",add_certificate:"ssl_certificates_add.png",delete_certificate:"ssl_certificates_delete.png",warning:"error.png",refresh:"arrow_refresh.png","add-by-pem":"add-by-pem.png","fetch-from-server":"fetch-cert-from-server.png","fetch-from-server-failed":"fetch-cert-from-server-failed.png"}})}});
NX.define("Nexus.ssl.repository.CertificateTab",{extend:"Nexus.ssl.AbstractCertificateTab",constructor:function(cfg){if(!cfg||!cfg.payload){throw new Error("payload missing: need repository record")}var data=cfg.payload.data,settings={frame:true,autoScroll:true,readOnly:true,data:data,certRequestParams:{repositoryId:data.id}};Ext.apply(cfg,settings);this.constructor.superclass.constructor.apply(this,arguments)}},function(){Sonatype.Events.addListener("repositoryViewInit",function(cardPanel,rec){var sp=Sonatype.lib.Permissions,newRecord,isProxyRepo;newRecord=rec.id&&rec.id.indexOf("new_")===0;isProxyRepo=rec.data.repoType==="proxy";if(!newRecord&&isProxyRepo&&((rec.data.remoteUri&&rec.data.remoteUri.startsWith("https"))||(rec.data.remoteStorage&&rec.data.remoteStorage.remoteStorageUrl&&rec.data.remoteStorage.remoteStorageUrl.startsWith("https")))&&(sp.checkPermission("nexus:repositories",sp.CREATE)||sp.checkPermission("nexus:repositories",sp.DELETE)||sp.checkPermission("nexus:repositories",sp.EDIT))){cardPanel.add(new Nexus.ssl.repository.CertificateTab({tabTitle:"SSL",name:"ssl",payload:rec}))}})});
NX.define("Nexus.ssl.certificate.FetchCertificateView",{extend:"Ext.Panel",requires:["Nexus.ssl.certificate.AddCertificateView"],requirejs:["Sonatype/utils","Nexus/config"],buttonAlign:"center",frame:true,asWindow:function(title){var self=this,window;window=new Ext.Window({title:title,width:450,height:self.windowHeight,layout:"fit",onEsc:function(){window.close()},items:[self]});self.on("added",function(){window.close()});return window},initComponent:function(){var self=this;self.buttons=[{text:"Load Certificate",handler:self.onLoad,scope:self}];self.items.unshift({xtype:"panel",name:"message",anchor:"100%",html:self.messageTemplate.apply({type:"text",icon:self.defaultMsgIcon,msg:self.defaultMsg})});Ext.Panel.prototype.initComponent.apply(self,arguments)},onLoad:function(){var self=this;self.loadmask=new Ext.LoadMask(self.el,{msg:"Loading certificate...",removeMask:true});self.loadmask.show();self.fetchPEM(Ext.createDelegate(self.showCertificate,self))},showCertificate:function(data){var self=this,details=self.find("name","certificate-details")[0],mask=new Ext.LoadMask(self.el,{msg:"Fetching certificate..."});if(self.loadmask){self.loadmask.hide()}if(data.id){self.certificate=data;self.createCertificateDetailView(data).show();self.findParentByType("window").close()}else{if(data.pem){mask.show();Ext.Ajax.request({url:Sonatype.config.contextPath+"/service/siesta/ssl/certificates/details",defaultErrorMessage:"Could not add certificate.",suppressStatus:400,jsonData:{value:data.pem},success:self.confirmCertificate(mask),failure:function(response){mask.hide();var message="Could not add certificate to Nexus<br/>";if(response.siestaError){message+=response.siestaError.message}else{if(response.siestaValidationError){Ext.each(response.siestaValidationError,function(error){message+=error.message+"<br/>"})}else{message+=Sonatype.utils.parseHTMLErrorMessage(response.responseText)}}self.showErrorMessage(message)}})}}},messageTemplate:new Ext.XTemplate('<div class="nx-ssl-fetchcert-message-icon">',"{[Nexus.ssl.Icons.get(values.icon).img]}","</div>",'<div class="nx-ssl-fetchcert-message-{type}">',"{msg}","</div>"),showMessage:function(message,type){if(!type){type="text"}var self=this,panel=self.find("name","message")[0];if(panel.getEl()){self.messageTemplate.overwrite(panel.getEl(),{icon:"fetch-from-server-failed",msg:message,type:type})}if(self.loadmask){self.loadmask.hide()}},showErrorMessage:function(message){this.showMessage(message,"error")},confirmCertificate:function(mask){var self=this;return function(response){if(mask){mask.hide()}self.certificate=Ext.decode(response.responseText);self.createCertificateDetailView(self.certificate).show();self.findParentByType("window").close()}},createCertificateDetailView:function(certificate){return Ext.create({xtype:"add-certificate-window",certificate:certificate})}});
NX.define("Nexus.ssl.certificate.AddByServerFetch",{extend:"Nexus.ssl.certificate.FetchCertificateView",xtype:"ssl-add-by-server",requires:["Nexus.ssl.Icons"],layout:"anchor",windowHeight:175,defaultMsgIcon:"fetch-from-server",defaultMsg:"Please enter a hostname, hostname:port or a URL to fetch a SSL certificate from.",initComponent:function(){var self=this;self.items=[{xtype:"textfield",name:"host",style:"margin: 10px;",anchor:"100%",listeners:{afterrender:{fn:function(cmp){cmp.focus(false,100)},single:true},specialkey:function(field,evt){switch(evt.getKey()){case evt.RETURN:case evt.ENTER:self.onLoad();break}}}}];self.constructor.superclass.initComponent.apply(self,arguments)},parseHostString:function(str){if(!str){return[]}if(str.indexOf(":")===-1){return[str]}if(str.indexOf("/")===-1){return str.split(":")}var rx=/[^:]*:\/\/([^:\/]*)(:([0-9]*))?/,matches=str.match(rx);if(matches){return[matches[1],matches[3]]}return[str]},fetchPEM:function(){var self=this,url=self.find("name","host")[0].getValue(),detail=self.parseHostString(url),host=detail[0],port=detail[1]||443;Ext.Ajax.request({url:Sonatype.config.contextPath+"/service/siesta/ssl/certificates",method:"GET",params:{host:host,port:port},suppressStatus:[400,404],success:function(response){self.showCertificate(Ext.decode(response.responseText))},failure:function(response){var message="Could not fetch certificate from host '"+host+":"+port+"'.<br/>";if(response.siestaError){message+=response.siestaError.message}else{if(response.siestaValidationError){Ext.each(response.siestaValidationError,function(error){message+=error.id+": "+error.message+"<br/>"})}else{message+=Sonatype.utils.parseHTMLErrorMessage(response.responseText)}}self.showErrorMessage(message)}})}});
NX.define("Nexus.ssl.certificate.AddByPEM",{extend:"Nexus.ssl.certificate.FetchCertificateView",xtype:"ssl-add-by-pem",windowHeight:300,defaultMsgIcon:"add-by-pem",defaultMsg:"Please paste a SSL certificate in PEM format.",layout:"anchor",padding:10,initComponent:function(){var self=this;self.items=[{xtype:"textarea",name:"pem",style:"margin: 10px;",anchor:"100% -40",listeners:{afterrender:{fn:function(cmp){cmp.focus(false,100)},single:true}}}];self.constructor.superclass.initComponent.apply(self,arguments)},fetchPEM:function(){this.showCertificate({pem:this.find("name","pem")[0].getValue()})}});
NX.define("Nexus.ssl.certificate.AddCertificateView",{extend:"Ext.Window",xtype:"add-certificate-window",title:"Add certificate",width:550,height:450,layout:"fit",onEsc:function(){this.close()},initComponent:function(){var self=this;self.items=[{xtype:"certificate-details",certificate:self.certificate}];self.buttons=[{xtype:"button",text:"Add Certificate",handler:function(){self.addCertificate(self.certificate.pem)}}];self.constructor.superclass.initComponent.apply(self,arguments)},addCertificate:function(pem){var self=this,loadmask=new Ext.LoadMask(self.getEl(),{msg:"Adding certificate",removeMask:true});Ext.Ajax.request({url:Sonatype.config.contextPath+"/service/siesta/ssl/truststore",defaultErrorMessage:"Could not add certificate.",jsonData:{value:pem},callback:function(){loadmask.hide()},success:function(){self.close();Nexus.ssl.CertificateStore.reload()}})}});
NX.define("Nexus.ssl.certificate.CertificateDetailsView",{extend:"Ext.Panel",statics:{NO_DETAIL:{xtype:"panel",html:'<p style="margin: 15px">Select a certificate to display its details.</p>'},COULD_NOT_RETRIEVE:{xtype:"panel",html:'<p style="margin: 15px; color: red;">Could not retrieve the certificate.</p>'},RETRIEVE_ERROR:function(errorMessage){return{xtype:"panel",frame:true,html:'<p style="margin: 15px; color: red;">Could not retrieve the certificate:<br/>'+errorMessage+"</p>"}}},xtype:"certificate-details",initComponent:function(){var self=this,subject,issuer,validity;self.data=self.certificate;self.defaults={readonly:true};self.layout="form";if(self.initialConfig.frame===undefined){self.frame=true}self.autoScroll=true;subject={xtype:"fieldset",title:"Subject",items:[{xtype:"displayfield",fieldLabel:"Common Name",value:self.data.subjectCommonName},{xtype:"displayfield",fieldLabel:"Organisation",value:self.data.subjectOrganization},{xtype:"displayfield",fieldLabel:"Unit",value:self.data.subjectOrganizationalUnit}]};issuer={xtype:"fieldset",title:"Issuer",items:[{xtype:"displayfield",fieldLabel:"Common Name",value:self.data.issuerCommonName},{xtype:"displayfield",fieldLabel:"Organisation",value:self.data.issuerOrganization},{xtype:"displayfield",fieldLabel:"Unit",value:self.data.issuerOrganizationalUnit}]};validity={xtype:"fieldset",title:"Certificate",items:[{xtype:"timestampDisplayField",fieldLabel:"Issued On",value:self.data.issuedOn},{xtype:"timestampDisplayField",fieldLabel:"Valid until",value:self.data.expiresOn},{xtype:"displayfield",fieldLabel:"Fingerprint",value:self.data.fingerprint}]};self.items=[subject,issuer,validity];self.constructor.superclass.initComponent.apply(self,arguments)}});
(function(){var sp=Sonatype.lib.Permissions,may,mayDelete,removeMessage;may=function(term){return sp.checkPermission("nexus:ssl:truststore",term)};mayDelete=function(){return may(sp.DELETE)};removeMessage=new Ext.XTemplate("Remove the following certificates?<br/>","(You need to restart Nexus to make sure certificates are not cached anymore)<br/><br/>",'<tpl for=".">','<tpl for="data">',"{subjectCommonName}<br/>","</tpl>","</tpl>",{disableFormats:true,compiled:true});NX.define("Nexus.ssl.configuration.CertificateManagerGrid",{extend:"Ext.grid.EditorGridPanel",requireSuper:false,requirejs:["Nexus/config"],requires:["Nexus.ssl.Icons","Nexus.ssl.CertificateStore","Nexus.ssl.certificate.AddByServerFetch","Nexus.ssl.certificate.AddByPEM"],xtype:"certificate-manager",mixins:["Nexus.LogAwareMixin"],select:function(id){var self=this,record;if(id){record=self.store.query("id",id).get(0);if(record){if(record.id!==self.selectedId){if(self.getView().getRows().length===0){self.on("viewready",function(){self.getSelectionModel().selectRecords([record]);self.selectedId=id},self,{single:true})}else{self.getSelectionModel().selectRecords([record],true);self.selectedId=id;return true}}}}return false},initComponent:function(){var self=this,icons=Nexus.ssl.Icons;self.border=true;self.selModel=new Ext.grid.RowSelectionModel({listeners:{selectionchange:function(selModel){self.getTopToolbar().get("remove").setDisabled(!selModel.hasSelection())},rowselect:function(selModel,idx,record){self.fireEvent("certSelected",record)},rowdeselect:function(selModel,idx,record){self.fireEvent("certDeselected",record)}}});self.store=Nexus.ssl.CertificateStore;self.tbar=[{iconCls:icons.get("refresh").cls,text:"Refresh",handler:function(){self.store.reload()}},{iconCls:icons.get("add_certificate").cls,text:"Add...",menu:[{text:"Load from server",handler:function(){Ext.create({xtype:"ssl-add-by-server"}).asWindow("Load certificate from server").show()}},{text:"Paste PEM",handler:function(){Ext.create({xtype:"ssl-add-by-pem"}).asWindow("Paste certficate as PEM").show()}}]},{text:"Delete",itemId:"remove",iconCls:icons.get("delete_certificate").cls,disabled:true,handler:function(){var records=self.getSelectionModel().getSelections();Sonatype.utils.defaultToNo();Sonatype.MessageBox.show({animEl:this.getEl(),title:"Delete selected certificates?",msg:removeMessage.apply(records),buttons:Sonatype.MessageBox.YESNO,scope:this,icon:Sonatype.MessageBox.WARNING,fn:function(btnName){if(btnName==="yes"||btnName==="ok"){Ext.each(records,function(record){self.store.remove(record)});self.store.reload();self.fireEvent("certsRemoved",records)}}})},hidden:!mayDelete()}];self.autoExpandColumn="fingerprint";self.colModel=new Ext.grid.ColumnModel({defaultSortable:true,columns:[{width:25,resizable:false,sortable:false,fixed:true,hideable:false,menuDisabled:true,renderer:function(value,metaData,record){return icons.get("certificate").img}},{header:"Name",dataIndex:"subjectCommonName",width:100},{header:"Issued To",dataIndex:"subjectOrganization",width:100},{header:"Issued By",dataIndex:"issuerOrganization",width:100},{id:"fingerprint",header:"Fingerprint",dataIndex:"fingerprint"}]});self.on("rowclick",function(grid,idx){self.selectedId=self.store.getAt(idx).id});self.constructor.superclass.initComponent.apply(self,arguments);self.on("render",function(){self.mask=new Ext.LoadMask(self.getGridEl(),{msg:"Loading certificates...",store:self.store});self.store.load()});self.on("beforedestroy",function(){self.mask.disable()})}})}());
NX.define("Nexus.ssl.configuration.GlobalConfigurationView",{extend:"Ext.Panel",requires:["Nexus.ssl.configuration.CertificateManagerGrid","Nexus.ssl.certificate.CertificateDetailsView","Nexus.ssl.Icons"],statics:{tabId:"nexus-ssl-global-config"},showDetails:function(id){var self=this,grid,record,icons=Nexus.ssl.Icons;self.detailsView.removeAll();if(!id){self.detailsView.add(Nexus.ssl.certificate.CertificateDetailsView.NO_DETAIL);self.detailsView.setTitle("No Selection",icons.get("warning").cls);self.doLayout();return}grid=self.findByType("certificate-manager")[0];record=grid.store.query("id",id).get(0);if(record===undefined){self.detailsView.add(Nexus.ssl.certificate.CertificateDetailsView.NO_DETAIL);self.detailsView.setTitle("No Selection",icons.get("warning").cls)}else{self.detailsView.add({xtype:"certificate-details",autoDestroy:true,certificate:record.data});self.detailsView.setTitle(record.data.subjectCommonName,icons.get("certificate").cls)}self.doLayout()},initComponent:function(){var self=this;self.layout="border";self.detailsView=NX.create("Ext.Panel",{title:"No Selection",iconCls:Nexus.ssl.Icons.get("warning").cls,region:"south",layout:"fit",split:true,border:true,items:[Nexus.ssl.certificate.CertificateDetailsView.NO_DETAIL],listeners:{afterrender:{fn:function(cmp){cmp.setHeight(self.getHeight()/1.5)},single:true}}});self.certificateManager=NX.create("Nexus.ssl.configuration.CertificateManagerGrid",{xtype:"certificate-manager",region:"center",listeners:{certsRemoved:function(){self.showDetails(null)},certSelected:function(record){self.bookmark=record.id;Sonatype.utils.updateHistory(self);self.showDetails(record.id)},certDeselected:function(record){if(self.bookmark===record.id){self.showDetails(null)}}}});self.items=[self.certificateManager,self.detailsView];self.constructor.superclass.initComponent.apply(self,arguments)},getBookmark:function(){return this.bookmark},applyBookmark:function(bookmark){var self=this,grid;self.bookmark=bookmark;grid=self.findByType("certificate-manager")[0];grid.select(bookmark);self.showDetails(bookmark)}},function(){Sonatype.Events.addListener("nexusNavigationInit",function(panel){var sp=Sonatype.lib.Permissions;if(sp.checkPermission("nexus:ssl:truststore",sp.READ)){panel.add({title:"SSL Certificates",tabId:Nexus.ssl.configuration.GlobalConfigurationView.tabId,tabCode:Nexus.ssl.configuration.GlobalConfigurationView,sectionId:"st-nexus-config"})}})});
define("nexus-ssl-plugin-boot",["Nexus/ssl/configuration/GlobalConfigurationView","Nexus/ssl/repository/CertificateTab"]);
